Last Comment Bug 747921 - Intermittent failures on app installation on windows 7
: Intermittent failures on app installation on windows 7
Status: VERIFIED FIXED
[marketplace-beta+]
:
Product: Firefox Graveyard
Classification: Graveyard
Component: Web Apps (show other bugs)
: unspecified
: x86 Windows 7
: -- normal
: Firefox 15
Assigned To: :Felipe Gomes (needinfo me!)
: Jason Smith [:jsmith]
:
Mentors:
: 749100 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-04-23 08:17 PDT by Anant Narayanan [:anant]
Modified: 2016-02-04 15:00 PST (History)
7 users (show)
jsmith: in‑moztrap-
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Patch (929 bytes, patch)
2012-04-25 11:20 PDT, :Felipe Gomes (needinfo me!)
timabraldes: review+
Details | Diff | Splinter Review

Description Anant Narayanan [:anant] 2012-04-23 08:17:42 PDT
Timestamp: 4/23/2012 8:09:57 AM
Error: Error installing app: [Exception... "Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIWindowsRegKey.open]"  nsresult: "0x80004005 (NS_ERROR_FAILURE)"  location: "JS frame :: resource:///modules/WebappsInstaller.jsm :: <TOP_LEVEL> :: line 224"  data: no]
Source File: resource:///modules/WebappsInstaller.jsm
Line: 36
Comment 1 Myk Melez [:myk] [@mykmelez] 2012-04-23 09:18:56 PDT
Which app(s) did you try to install?  And from which website (f.e. marketplace-dev.allizom.org)?  And while running which nightly build?  A bit more information would be most helpful. ;-)
Comment 2 Jason Smith [:jsmith] 2012-04-23 09:20:13 PDT
Not getting a reproduction of this bug on Win 7 64-bit with the current nightly. Anant could you clarify the following things:

- What build are you running (e.g. the latest nightly)
- If the problem still reproduces with the current nightly
- Reproduction steps
Comment 3 Anant Narayanan [:anant] 2012-04-23 09:24:37 PDT
Sorry, I mostly just wanted to log the error message so we don't forget. The problem occurred on Todd's Windows Laptop this morning, and he will followup with information on his setup shortly.
Comment 4 Todd 2012-04-23 09:28:36 PDT
Windows: Win 7, version 6.1
Nightly: 14.0a1 (2012-04-23)

https://marketplace.mozilla.org/en-US/
Tried: Lord of Ultima, Boston Globe, GodFather, Lanyard, etc....
Reproduce: click install on any app.   Gives error message "App Installation not allowed"
Comment 5 Anant Narayanan [:anant] 2012-04-23 09:36:48 PDT
STR:
The error occurs when installing an app from anywhere (I just tried installing one from the mozillalabs appdir). It's the latest nightly from today.

I have a hunch that this has something to do with permissions (the current user being unable to write to the registry), or that the registry is just corrupt.
Comment 6 Jason Smith [:jsmith] 2012-04-23 12:16:42 PDT
(In reply to Anant Narayanan [:anant] from comment #5)
> I have a hunch that this has something to do with permissions (the current
> user being unable to write to the registry), or that the registry is just
> corrupt.

      uninstallKey.open(uninstallKey.ROOT_KEY_CURRENT_USER,
                        "SOFTWARE\\Microsoft\\Windows\\" +
                        "CurrentVersion\\Uninstall",
                        uninstallKey.ACCESS_WRITE);

That's the line of code where the failure is occurring. Does not look like it happens on every machine, only certain Windows machines. I agree with Anant - Sounds like this might be a permissions issue. Tim - Any ideas?
Comment 7 Anant Narayanan [:anant] 2012-04-23 14:35:04 PDT
Looking at the code a bit more, it looks like we're checking the registry to see if the app was previously installed and if so, we remove it. I think failure to do so shouldn't raise an error in the install process, or maybe we can punt on it until later on when we try to add a registry key?

Anyway, that's just a band-aid, we still have to figure out the core problem of why that Component is failing on that particular Windows setup.
Comment 8 Ragavan S [:rags] 2012-04-24 23:23:00 PDT
I just tested this on a Win 7 machine and got an App manifest is invalid error.
Comment 9 Ragavan S [:rags] 2012-04-24 23:32:12 PDT
This is what I see in the error console when I tried to install the Evernote app:

marketplace-dev.allizom.org : server does not support RFC 5746, see CVE-2009-3555
stage.evernote.com : server does not support RFC 5746, see CVE-2009-3555
Comment 10 Ragavan S [:rags] 2012-04-24 23:36:25 PDT
According to SUMO, it appears this may be related to some issue with Java? Really? http://support.mozilla.org/en-US/questions/746438
Comment 11 Ragavan S [:rags] 2012-04-24 23:45:00 PDT
I was able to successfully install Sandglaz, but Evernote and Boston Globe failed.
Comment 12 Anant Narayanan [:anant] 2012-04-24 23:56:47 PDT
The CVE messages are just warnings, they are not the cause of the problem.
Comment 13 Jason Smith [:jsmith] 2012-04-25 00:00:22 PDT
(In reply to Ragavan S [:rags] from comment #11)
> I was able to successfully install Sandglaz, but Evernote and Boston Globe
> failed.

Sounds like what you are describing an existing marketplace dev bug - bug 747252.
Comment 14 Jason Smith [:jsmith] 2012-04-25 00:28:53 PDT
Hmm. I got an idea for testing that might reveal the root cause of this issue - We had a problem in the past with the extension involving "fresh" builds of windows 7 I think that involved registry keys (bug 723355). As a result, the application could not be installed on the user's machine. However, when they installed Chrome on their machine, a certain registry key was written, which as a result, lead to allowing app installations.

First, do we know if logic behind bug 723355 was taken into account in the new implementation? Checking the diff, I wonder if this is correct. Myk or Tim - Could you take a look at the patch on that bug and comment here on your opinion?

I'll see if I get a fresh build of Windows 7 to test this.

Todd - Could you give me more details on the machine information - Things like how long you've had the windows 7 OS installed, how old the machine is, whether you've installed Chrome on that machine or not, etc.
Comment 15 Jason Smith [:jsmith] 2012-04-25 00:37:05 PDT
Followup questions to comment 14:

Myk or Tim - If the registry key in comment 6 doesn't exist, do we ensure we create it to avoid erroring out?

Todd - We might want to look at the windows registry on your machine.
Comment 16 :Felipe Gomes (needinfo me!) 2012-04-25 11:20:58 PDT
Created attachment 618366 [details] [diff] [review]
Patch

Straightforward. The code that _creates_ the key had no problem dealing with the nonexistent key, it's only the code that tries to clean-up a previous installation first that wasn't coping well.
Comment 17 Tim Abraldes [:TimAbraldes] [:tabraldes] 2012-04-25 14:24:23 PDT
Comment on attachment 618366 [details] [diff] [review]
Patch

Review of attachment 618366 [details] [diff] [review]:
-----------------------------------------------------------------

Tested locally and chatted with Felipe about the patch.  Looks good!
Comment 18 :Felipe Gomes (needinfo me!) 2012-04-26 07:44:54 PDT
https://hg.mozilla.org/mozilla-central/rev/2b118a11328b
Comment 19 :Felipe Gomes (needinfo me!) 2012-04-26 08:01:06 PDT
*** Bug 749100 has been marked as a duplicate of this bug. ***
Comment 20 Jason Smith [:jsmith] 2012-04-27 15:35:19 PDT
Verified through Todd today in the apps show and tell.

Note You need to log in before you can comment on or make changes to this bug.